OpenVDB: MeshToVoxelEdgeData Class Reference

OpenVDB 12.1.1

Loading...
Searching...
No Matches
MeshToVoxelEdgeData Class Reference

Extracts and stores voxel edge intersection data from a mesh. More...

`#include <openvdb/tools/MeshToVolume.h>`

## Classes
struct | EdgeData
| Internal edge data type. More...
class | GenEdgeData

## Public Types
using | TreeType = tree::Tree4<EdgeData, 5, 4, 3>::Type
using | Accessor = tree::ValueAccessor<TreeType>

## Public Member Functions
| MeshToVoxelEdgeData ()
void | convert (const std::vector< Vec3s > &pointList, const std::vector< Vec4I > &polygonList)
| Threaded method to extract voxel edge data, the closest intersection point and corresponding primitive index, from the given mesh.
void | getEdgeData (Accessor &acc, const Coord &ijk, std::vector< Vec3d > &points, std::vector< Index32 > &primitives)
| Returns intersection points with corresponding primitive indices for the given `ijk` voxel.
Accessor | getAccessor ()

## Detailed Description

Extracts and stores voxel edge intersection data from a mesh.

## Member Typedef Documentation

## ◆ Accessor

using Accessor = tree::ValueAccessor<TreeType>

## ◆ TreeType

using TreeType = tree::Tree4<EdgeData, 5, 4, 3>::Type

## Constructor & Destructor Documentation

## ◆ MeshToVoxelEdgeData()

MeshToVoxelEdgeData | ( |  | ) |
| inline

## Member Function Documentation

## ◆ convert()

void convert | ( | const std::vector< Vec3s > & | pointList,
|  | const std::vector< Vec4I > & | polygonList )
| inline

Threaded method to extract voxel edge data, the closest intersection point and corresponding primitive index, from the given mesh.

Parameters

  pointList | List of points in grid index space, preferably unique and shared by different polygons.
  polygonList | List of triangles and/or quads.

## ◆ getAccessor()

Accessor getAccessor | ( |  | ) |
| inline

Returns
  An accessor of `MeshToVoxelEdgeData::Accessor` type that provides random read access to the internal tree.

## ◆ getEdgeData()

void getEdgeData | ( | Accessor & | acc,
|  | const Coord & | ijk,
|  | std::vector< Vec3d > & | points,
|  | std::vector< Index32 > & | primitives )
| inline

Returns intersection points with corresponding primitive indices for the given `ijk` voxel.